
Table table;
Table descriptionTable;
int numRows, numColumns;
int numDescRows, numDescColumns;

float[][] dataMatrix;
float[][] originalMatrix;
String [][] descMatrix;
float maxValue, minValue;

//rects
int horMargin = 160;
int verMargin = 40;
int topMargin = 10;
float cellWidth, cellHeight;
int alphaVal = 255;
int alphaDelta = 255;
int highlightedRow = -1;

//Labels
int startYear = 2006;
int endYear = 2014;

int circleRadius = 13;

//color and normalization
boolean normalization = false;
boolean normalizationChanged = false;
boolean colorApplied = false;
boolean reorder = false;
boolean ellipse = true;
PImage colorBar;
String[] colorPath = {"greengray.png", "purple.png", "burntyellow.png"};
int colorType = 0;

String[] coverImages = {"true_diary.jpg","captain_underpants.jpg","huck_finn.jpg","tango.jpg","athletic_shorts.jpg", "bad_boy.jpg", "bless_me_ultima.jpg","bluest_eye.jpg",
                        "bone.jpg", "brave_new.jpg","catcher.jpg","chocolate.jpg", "color_earth.jpg","color_purple.jpg","crank.jpg","drama.jpg", "earth_butt.jpg",
                        "fifty_shades.jpg", "flashcards.jpg","glass_castle.jpg","golden_compass.jpg","gossip_girl.jpg","hunger_games.jpg", "caged_bird.jpg", 
                        "perfectly_normal.jpg","kite_runner.jpg","alaska.jpg","lush.jpg","mom_baby.jpg", "sisters_keeper.jpg","nickel_and_dimed.jpg","olives_ocean.jpg",
                        "perks.jpg","persepolis.jpg","revolutionary_voices.jpg","saga.jpg","scary_stories.jpg","alice.jpg","stolen_life.jpg","thirteen_reasons.jpg",
                        "mockingbird.jpg","ttyl.jpg","twilight.jpg","bobbys_wedding.jpg","mother_doesnt_know.jpg"};
PImage[] cImages = new PImage[45];
String[] reflectionImages= {"huck_finn_reflect.png", ""};
PImage[] reflections = new PImage[45];

void printDataMatrix(){
   for(int i=0; i<numColumns; i++){
    for(int j=0; j<numRows; j++){
      print(dataMatrix[i][j]);
    }
    println();
   }
}

void setup(){
  size(1440, 800);
  surface.setResizable(true);
  
  //load all the images
  for(int i=0; i<coverImages.length; i++){
   cImages[i] = loadImage(coverImages[i]);
  }
  
  //load all the reflections
  for(int i=0; i<reflections.length; i++){
   reflections[i] = loadImage(coverImages[i].substring(0, (coverImages[i].length() - 4)) + "_reflect.png");
  } //<>//

  //set the pixel density for retina display
  //int d = displayDensity();
  pixelDensity(2);
  
  //load the descriptions
  /*descriptionTable = loadTable("BookDescriptions.csv");
  numDescRows = descriptionTable.getRowCount();
  numDescColumns = descriptionTable.getColumnCount();
  for (int i=0; i<numDescRows; i++){
    for (int j=0; j < numDescColumns; j++){
       descMatrix[i][j] = table.getString(i,j);
    }
  }*/
  
  
  //load the data from the csv
  table = loadTable("FrequentlyChallengedList.csv","csv");
  numRows = table.getRowCount();
  numColumns = table.getColumnCount();
  
  dataMatrix = new float[numColumns][numRows];
  println("Rows: " + numRows + " Columns: " + numColumns);
  
  maxValue = 0;
  dataMatrix = new float[numColumns][numRows];
  originalMatrix = new float[numColumns][numRows];
  for(int i=0; i<numColumns; i++){
    for(int j=0; j<numRows; j++){
      dataMatrix[i][j] = table.getFloat(j, i);
      originalMatrix[i][j] = table.getFloat(j, i);
      if(dataMatrix[i][j] > maxValue){
        maxValue = dataMatrix[i][j];
      }
    }
  }
  
 // printDataMatrix();
  
  minValue = maxValue;
  for(int i=0; i<numColumns; i++){
    for(int j=0; j<numRows; j++){
      dataMatrix[i][j] = table.getFloat(j, i);
      if(dataMatrix[i][j] < minValue){
        minValue = dataMatrix[i][j];
      }
    }
  }
  
  println("Max Value: " + maxValue);
  println("Min Value: " + minValue);
  
  //print the available fonts
   //String[] fontList = PFont.list();
  //printArray(fontList);
}

void update(int x, int y) {
  
     //Add Vertical Labels
  if(highlightedRow != -1){
     alphaVal = alphaVal - alphaDelta; 
  }else{
    alphaVal = 255;
  }
  highlightedRow = -1;
 
  //Check if our mouse is in any circle
    for(int i=0; i<numColumns; i++){
      for(int j=0; j<numRows; j++){
        if((ellipse && mouseinCircle( horMargin + cellWidth*j + cellWidth/2, topMargin + cellHeight*i + cellHeight / 2, circleRadius)) 
        || (!ellipse &&  mouseinRect(horMargin + 50 + (cellWidth)*j, topMargin + cellHeight*i ,cellWidth,cellHeight))){
            PFont myFont = createFont("Helvetica-Light", 10);
            textFont(myFont);   
            fill(255);
            textAlign(CENTER, CENTER);
            highlightedRow = i;
            for (int k=0; k<numRows; k++){
              text((int)(originalMatrix[i][k]), horMargin + cellWidth*k + cellWidth/2 + 20, topMargin + cellHeight*i + cellHeight / 2);
            }
        }
      }
    }
}

boolean mouseinCircle(float x, float y, int circleRadius) {
  float disX = x - mouseX;
  float disY = y - mouseY;
  if(sqrt(sq(disX) + sq(disY)) < circleRadius/2 ) {
    return true;
  } else {
    return false;
  }
  
}

boolean mouseinRect(float x, float y, float w, float h){
  if(mouseX >= x && mouseX <= x+ w && mouseY >= y && mouseY <= y+h){
    return true;
  }else{
   return false; 
  }
}
void drawBanned(float x, float y, float radius){
   
   stroke(255, 0, 0);
   strokeWeight(3);
   ellipse(x, y, radius, radius);
   int offset = 7;
   line(x + (-sqrt(2)/ 2) * (radius-offset), y + (-sqrt(2)/ 2) * (radius-offset), x + (sqrt(2)/ 2) * (radius-offset), y + (sqrt(2)/ 2) * (radius - offset)); 
}

void drawBannedRect(float x, float y, float w, float h){
 stroke(255,0,0);
 strokeWeight(3);
 rect(x, y, w, h); 
 noStroke();
}

void draw(){
  //background(#282D48); //<>//
  background(0);
  cellWidth = (width - 2*horMargin)/numRows;
  cellHeight = (height - 2*verMargin)/(numColumns);
   //Drawing 2D Matrix on cavas
    for(int i=0; i<numColumns; i++){
      for(int j=0; j<numRows; j++){
        float brightness = map(dataMatrix[i][j], minValue, maxValue, 255, 0);
        
        //fade out the other rows if we've selected one
        if (highlightedRow == i){
         
            PImage img = cImages[highlightedRow];
            int offset = 0;
            if(highlightedRow <=12){
              offset = 150;
            }else if(highlightedRow <= 20){
              offset = 100; 
            }else if(highlightedRow <= 30) {
              offset = -350;
            }else if(highlightedRow <= 45){
              offset = -500; 
            }
            
            float titleY = ((cellHeight*i) - topMargin) / 4;  
            float imageY = ((cellHeight*i) - topMargin) / 2;  
            if(highlightedRow <= 20){
              titleY = (cellHeight * i) + ((height - verMargin) - (cellHeight*i)) / 4;
              imageY = (cellHeight * i) + ((height - verMargin) - (cellHeight*i)) / 2;
            }
            
            PFont newFont = createFont("Helvetica-Light", 24);
            fill (255);
            textFont(newFont);
            textAlign(RIGHT, CENTER);
           text(titles[highlightedRow],width-horMargin, titleY);  
                 
            PFont reasonFont = createFont("Helvetica-Light", 14);
            fill (180);
            textFont(reasonFont);
            textAlign(RIGHT, CENTER);
            text(reasons[highlightedRow], width-horMargin, titleY + 25); 
                 
            PFont myFont = createFont("Helvetica-Light", 14);
            fill(255);
            textFont(myFont);
            textAlign(RIGHT, TOP);
            text(descs[highlightedRow],width-horMargin-600, titleY + 75, 600, 600); 

            imageMode(CENTER);
            image(img,horMargin + cellWidth*2,imageY,img.width/2, img.height/2);
            PImage reflect = reflections[highlightedRow];
            image(reflect, horMargin + cellWidth*2,imageY + 20 + img.height/2,img.width/2, img.height/2);
            
            if(colorApplied){
              colorBar = loadImage(colorPath[colorType-1]);
              color c = colorBar.get((int)map(dataMatrix[i][j], minValue, maxValue, 2, colorBar.width-2), colorBar.height/2);
              fill(c, 255);
            }
            else{
              fill(brightness, 255);
            }
          
        }
        else{
           if(colorApplied){
              colorBar = loadImage(colorPath[colorType-1]);
              color c = colorBar.get((int)map(dataMatrix[i][j], minValue, maxValue, 2, colorBar.width-2), colorBar.height/2);
              if(highlightedRow == -1){
                fill(c, 255);
              }else{
                fill(c, 0);
              }
              
           }
           else{
             if(highlightedRow == -1){
               fill(brightness, 255);
             }else{
                fill(brightness, 0);
             }
          }
        }
        noStroke();
        //hide the grid
       
         if(BannedYears[i].contains(str(2006 + j)) && highlightedRow == i){
           if(ellipse){
             drawBanned(horMargin + cellWidth*j + cellWidth/2, topMargin + cellHeight*i + cellHeight / 2, circleRadius);
           }else{
             drawBannedRect(horMargin + 50 + (cellWidth)*j, topMargin + cellHeight*i,cellWidth,cellHeight);
           }
         }else{
           if(ellipse){
             ellipse(horMargin + cellWidth*j + cellWidth/2, topMargin + cellHeight*i + cellHeight / 2, circleRadius, circleRadius);
           }else{
             rect(horMargin + 50 + (cellWidth)*j, topMargin + cellHeight*i ,cellWidth,cellHeight);
           }
         }
     }
  }
    
     //Add Vertical Labels //<>//
  PFont myFont = createFont("Helvetica-Light", 10);
  textFont(myFont);   
  
  for(int i=0; i<titles.length; i++){
      fill(255);
      textAlign(RIGHT, CENTER);
      text(titles[i],horMargin + 40, topMargin + cellHeight/2 + cellHeight*i);
   }
  
  //Add title labels
   PFont newFont = createFont("Helvetica-Light", 10);
   textFont(newFont); 
   textAlign(CENTER, CENTER);
  
  //Add text labels
  for(int i=0; i<9; i++){
     pushMatrix();
     translate(horMargin + i * cellWidth + cellWidth/2, topMargin + cellHeight*(numColumns) + 20);
     //rotate(-45);
     textAlign(CENTER);
     text(startYear+i,0 ,0 );
     popMatrix();
  }
  
  //Draw Title
  textAlign(RIGHT, CENTER);
  textSize(18);
  text("frequently", width - topMargin, verMargin/2);
  text("challenged", width - topMargin, verMargin/2 + 20);
  text("titles", width - topMargin, verMargin/2 + 40);
  text("2006 - 2014", width - topMargin, verMargin/2 + 60);
  
  //Add the legend
  textAlign(RIGHT, CENTER);
  textSize(14);
  if(ellipse){
    text("checkout frequency", width - topMargin, height/2 );
  }else{
   text("checkout", width - topMargin, height/2 - 20 );
   text("frequency", width - topMargin, height/2 ); 
  }
   //<>//
  for (int i=0; i <13; i++){
    if (colorApplied == true){
      color c = colorBar.get((int)map(((maxValue - minValue) / 13) * i, minValue, maxValue, 2, colorBar.width-2), colorBar.height/2);
      fill(c);
    }
    else{
      float brightness = map(((maxValue - minValue) / 13) * i, minValue, maxValue, 255, 0);
      fill(brightness);
    }
    if(ellipse){
      ellipse(width - topMargin - 120 + (10*i), height/2 + 20 , circleRadius - 8, circleRadius - 8);
    }else{
       rect(width - topMargin - 100 + (10*i), height/2 + 20,10,5); 
    }
  }
   //<>//
  if(normalizationChanged && normalization == true){ 
    normalization();
    normalizationChanged = false;
  }
  else if(normalizationChanged && normalization == false) 
  {
    denormalize();
    normalizationChanged = false;
  }
  
  if(reorder){
    reorder();
  }  
   update(mouseX, mouseY);
}